;;; $Id: bexp-mod.tst,v 1.2 2006/02/14 03:25:56 leavens Exp $

(require (lib "bexp-mod.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (parse-bexp 'p) = (var-exp 'p) )
   ( (parse-bexp 'q) = (var-exp 'q) )
   ( (parse-bexp '(and (or p q) p))
     = (and-exp (or-exp (var-exp 'p) (var-exp 'q)) (var-exp 'p)) )
   ( (parse-bexp '(or (not p) q))
     = (or-exp (not-exp (var-exp 'p)) (var-exp 'q)) )

   ( (var-exp? (var-exp 'p)) ==> #t )
   ( (and-exp? (var-exp 'p)) ==> #f )
   ( (or-exp?  (var-exp 'p)) ==> #f )
   ( (not-exp? (var-exp 'p)) ==> #f )

   ( (var-exp? (and-exp (var-exp 'p) (var-exp 'q))) ==> #f )
   ( (and-exp? (and-exp (var-exp 'p) (var-exp 'q))) ==> #t )
   ( (or-exp?  (and-exp (var-exp 'p) (var-exp 'q))) ==> #f )
   ( (not-exp? (and-exp (var-exp 'p) (var-exp 'q))) ==> #f )

   ( (var-exp? (or-exp (var-exp 'p) (var-exp 'q))) ==> #f )
   ( (and-exp? (or-exp (var-exp 'p) (var-exp 'q))) ==> #f )
   ( (or-exp?  (or-exp (var-exp 'p) (var-exp 'q))) ==> #t )
   ( (not-exp? (or-exp (var-exp 'p) (var-exp 'q))) ==> #f )

   ( (var-exp? (not-exp (var-exp 'p))) ==> #f )
   ( (and-exp? (not-exp (var-exp 'p))) ==> #f )
   ( (or-exp?  (not-exp (var-exp 'p))) ==> #f )
   ( (not-exp? (not-exp (var-exp 'p))) ==> #t )

    )
 )
