;;; $Id: bintree-mod.scm,v 1.1 2006/01/01 00:29:07 leavens Exp $

(module bintree-mod (lib "typedscm.ss" "typedscm")

(provide bintree bintree? leaf-node interior-node)

(deftype bintree? (type-predicate-for bintree))
(deftype leaf-node (-> (number) bintree))
(deftype interior-node (-> (symbol bintree bintree) bintree))

(define-datatype bintree bintree? 
  (leaf-node 
    (datum number?))
  (interior-node
    (key symbol?) 
    (left bintree?)
    (right bintree?)))
)
