;;; $Id: ch3-1-modified-in-class.tst,v 1.1 2006/03/28 22:43:31 leavens Exp $
;;; Test cases for the 3-1 interpreter modified in class

(require (lib "ch3-1-modified-in-class.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (run "zero")
      ==> 0 )
    ( (run "+(zero, one)")
      ==> 1 )
    ( (run "/(25, 5)")
      ==> 5 )
    ( (run "/(342, one)")
      ==> 342 )
    ( (run "if 0 then 99 else 72")
      ==> 72 )
    ( (run "if one then 99 else 72")
      ==> 99 )
    ( (run "/(if +(zero, one) then let x = 3 in *(x,x) else x, one)")
      ==> 9 )
    ))
