;;; $Id: ch3-6-2-modified-in-class.tst,v 1.1 2006/03/28 22:43:31 leavens Exp $
;;; Test cases for the 3-6-2 interpreter modified in class

(require (lib "ch3-6-2-modified-in-class.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (run "letrec fact(x) = if zero?(x) then 1 else *(x, (fact sub1(x))) in (fact 3)")
      ==> 6 )
    ( (run "letrec
              even(n) = if zero?(n) then 1 else (odd sub1(n))
              odd(n) = if zero?(n) then 0 else (even sub1(n))
            in (odd 541)")
      ==> 1 )
    ( (run "namedlet fact (x = 3) if zero?(x) then 1 else *(x, (fact sub1(x)))")
      ==> 6 )
    ))
