;;; $Id: environment-tests.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $

(module environment-tests (lib "typedscm.ss" "typedscm")

(provide run-tests)

(define run-tests
  (lambda ()
    (run-regression-tests-equal?
     `(
       ( (apply-env (extend-env '(x y) '(3 4) (empty-env)) 'x) ==> 3 )
       ( (apply-env (extend-env '(x y) '(3 4) (empty-env)) 'y) ==> 4 )
       ( (apply-env (extend-env '(a b c x)
                                '(5 9 12 2)
                                (extend-env '(x y) '(3 4) (empty-env)))
                    'y) ==> 4 )
       ( (apply-env (extend-env '(a b c x)
                                '(5 9 12 2)
                                (extend-env '(x y) '(3 4) (empty-env)))
                    'x) ==> 2 )
       ( (apply-env (extend-env '(a b c x)
                                '(5 9 12 2)
                                (extend-env '(x y) '(3 4) (empty-env)))
                    'a) ==> 5 )
       ( (apply-env (extend-env '(a b c x)
                                '(5 9 12 2)
                                (extend-env '(x y) '(3 4) (empty-env)))
                    'b) ==> 9 )
       ( (apply-env (extend-env '(a b c x)
                                '(5 9 12 2)
                                (extend-env '(x y) '(3 4) (empty-env)))
                    'c) ==> 12 )
       ( (apply-env (extend-env '(a b c x)
                                '(5 9 12 2)
                                (extend-env
                                 '() '()
                                 (extend-env
                                  '() '()
                                  (extend-env '(x y) '(3 4) (empty-env)))))
                    'y) ==> 4 )
       )
     )
    ))

) ;; end module
