;;; $Id: iseq-map-mod.tst,v 1.2 2006/01/05 22:24:09 leavens Exp $

(require (lib "iseq-map-mod.scm" "lib342"))

(define ones (iseq 1 (lambda () ones)))
(define twos (iseq 2 (lambda () twos)))

(run-regression-tests-equal?
 `(

   ( (iseq->head (iseq-map (lambda (e) (+ 1 e)) ones)) ==> 2 )
   ( (iseq->head (iseq->tail (iseq->tail
                              (iseq-map (lambda (e) (+ 1 e)) ones))))
     ==> 2 )
   ( (iseq->head (iseq->tail (iseq->tail
                              (iseq-map odd? twos))))
     ==> #f )
   ( (iseq->head (iseq->tail (iseq->tail
                              (iseq-map even? twos))))
     ==> #t )

    )
 )
