;;; $Id: list-copy-mod.scm,v 1.1 2005/12/30 23:10:13 leavens Exp $
;;; AUTHOR: Brian Dorn and Gary T. Leavens

(module list-copy-mod (lib "typedscm.ss" "typedscm")

(provide list-copy)

(deftype list-copy (forall (t) (-> ((list-of t)) (list-of t))))
(define list-copy
  (lambda (l)
    ;; ENSURES: Result is a copy of l
    (cond
     ((null? l) '())
     (else (cons (car l) (list-copy (cdr l)))))))

) ;; end module
