;;; $Id: little-schemer.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $
;;; From The Little Schemer, p. xii

(module little-schemer (lib "typedscm.ss" "typedscm")

(provide add1 sub1 atom?)

(deftype add1 (-> (number) number))
(deftype sub1 (-> (number) number))
(deftype atom? (-> (datum) boolean))

(define add1
  (lambda (x) (+ x 1)))

(define sub1
  (lambda (x) (- x 1)))

(define atom?
  (lambda (x)
    (and (not (pair? x))
         (not (null? (has-type datum x))))))

) ;; end module
