;;; $Id: mapcdr-mod.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $
;;; AUTHOR: Dalei Li and Gary T. Leavens

(module mapcdr-mod (lib "typedscm.ss" "typedscm")

(provide mapcdr)

(deftype mapcdr
  (forall (t) (-> ((list-of (list-of t))) (list-of (list-of t)))))
(define mapcdr
  (lambda (lst)
    ;; ENSURES: Result is the list (map cdr lst)
    (if (null? lst)
        '()
        (cons (cdr (car lst)) (mapcdr (cdr lst))))))

) ;; end module

