;;; $Id: remove-sym-exp-tests.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $

(module remove-sym-exp-tests (lib "typedscm.ss" "typedscm")

(provide run-tests parse-sym-exp parse-s-list)

(require (lib "sym-exp-mod.scm" "lib342"))

(define run-tests
  (lambda ()
    (run-regression-tests-equal?
     `(
       ( (remove-sym-exp 'z (parse-sym-exp 'a))
         ==> (a) )
       ( (remove-sym-exp 'z (parse-sym-exp 'z))
         ==> () )
       ( (remove-sym-exp 'z (parse-sym-exp '()))
         ==> (()) )
       ( (remove-sym-exp 'z (parse-sym-exp '(w z (y z) () (x))))
         ==> ((w (y) () (x))) )

       ( (remove-s-list 'z (parse-s-list '()))
         ==> () )
       ( (remove-s-list 'z (parse-s-list '(z (y z) () (x))))
         ==> ((y) () (x)) )
       )
     )
    ))

) ;; end module
