;; $Id: ribassoc-mod.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $

(module ribassoc-mod (lib "typedscm.ss" "typedscm")

(provide ribassoc)

(deftype ribassoc
  (forall (T) (-> (symbol (list-of symbol) (vector-of T) T) T)))

(require (lib "list-index-find.scm" "lib342"))

(define ribassoc
  (lambda (s los v fail-value)
    ;; REQUIRES: (length los) = (vector-length v)
    ;; ENSURES: if s occurs in los and its first occurence has index i,
    ;; then result is the ith element of v; otherwise the result is fail-value.
   (let ((f (list-index s los)))
     (if (> f -1)
         (vector-ref v f)
         fail-value))))

) ;; end module
