;;; $Id: subst-mod.tst,v 1.3 2006/01/05 22:24:09 leavens Exp $

(require (lib "subst-mod.scm" "lib342")
         (lib "sym-exp-mod.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (subst 'y 'x (parse-s-list '())) ==> () )
   ( (subst 'y 'x (parse-s-list '(x y () (x)))) ==> (y y () (y)) )
   ( (subst 'y 'x (parse-s-list '(y () (x)))) ==> (y () (y)) )

   ( (subst-sym-exp 'x 'a (parse-sym-exp 'a)) ==> x )
   ( (subst-sym-exp 'x 'a (parse-sym-exp 'b)) ==> b )
   ( (subst-sym-exp 'x 'a (parse-sym-exp '(x y (x)))) 
     ==> (x y (x)) )
   ( (subst-sym-exp 'x 'a (parse-sym-exp '(y (x))))
     ==> (y (x)) )
    )
 )
