;;; $Id: vector-generator-mod.tst,v 1.1 2005/12/24 22:02:29 leavens Exp $

(require (lib "vector-generator-mod.scm" "lib342"))

(define v '#(3 4 2))

(run-regression-tests-equal?
 `(
    ( ((vector-generator (lambda (i) i)) 0) ==> #() )
    ( ((vector-generator (lambda (i) i)) 3) ==> #(0 1 2) )
    ( ((vector-generator (lambda (i) (+ (vector-ref v i) 1))) 3)
      ==> #(4 5 3) )
    ( ((vector-generator (lambda (i) (vector-ref v i))) (vector-length v))
      = v )
    )
 )

