;;; $Id: lambda-1-quote-exp-tests.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $

(module lambda-1-quote-exp-tests (lib "typedscm.ss" "typedscm")

(provide run-tests)

(define run-tests
  (lambda ()
    (run-regression-tests-equal?
     `(
       ( (expression? (var-exp 'x)) ==> #t )
       ( (expression? (quote-exp 'x)) ==> #t )
       ( (expression?
          (lambda-exp 'x (app-exp (var-exp 'f) (var-exp 'x))))
         ==> #t )

       ( (parse-expression
          '((lambda (x) (f x)) z))
         = (app-exp 
            (lambda-exp 'x (app-exp (var-exp 'f) (var-exp 'x)))
            (var-exp 'z)) )
       )
     )
    ))

) ;; end module
