;;; $Id: phone-book-tests.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $

(module phone-book-tests (lib "typedscm.ss" "typedscm")

(provide run-tests)

(define run-tests
  (lambda ()
    (run-regression-tests-equal?
     `(
       ( (look-up (add-to-phone-book 'amy 5551212 (create-empty-phone-book))
                  'amy)
         ==> 5551212 )
       ( (look-up
          (add-to-phone-book
           'bob 4445454
           (add-to-phone-book
            'amy 5551212 (create-empty-phone-book)))
          'amy)
         ==> 5551212 )
       ( (look-up
          (add-to-phone-book
           'bob 4445454
           (add-to-phone-book
            'amy 5551212 (create-empty-phone-book)))
          'bob)
         ==> 4445454 )
       ( (look-up
          (add-to-phone-book
           'clara 3332211
           (add-to-phone-book
            'bob 4445454
            (add-to-phone-book
             'amy 5551212 (create-empty-phone-book))))
          'clara)
         ==> 3332211 )
       ( (look-up
          (add-to-phone-book
           'clara 3332211
           (add-to-phone-book
            'bob 4445454
            (add-to-phone-book
             'amy 5551212 (create-empty-phone-book))))
          'amy)
         ==> 5551212 )
       )
     )
    ))

) ;; end module
