;;; $Id: seq-tests.scm,v 1.1 2005/12/30 00:43:13 leavens Exp $

(module seq-tests (lib "typedscm.ss" "typedscm")

(provide run-tests)

(define run-tests
  (lambda ()
    (run-regression-tests-equal?
     `(
       ( (seq-nth (seq-repeat 342) 10) ==> 342 )
       ( (seq-nth (seq-repeat 342) 0) ==> 342 )
       ( (seq-nth (seq-generator (lambda (n) (+ n 5))) 0) ==> 5 )
       ( (seq-nth (seq-generator (lambda (n) (+ n 5))) 10) ==> 15 )
       ( (seq-nth (seq-generator (lambda (n) (+ (* n n) 10))) 1) ==> 11 )
       ( (seq-nth (seq-generator (lambda (n) (+ (* n n) 10))) 5) ==> 35 )
       )
     )
    ))

);; end module
