;;; $Id: temperature-mod.tst,v 1.1 2006/01/04 07:00:55 leavens Exp $

(require (lib "temperature-mod.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (parse-temperature 'hot) = (hot) )
   ( (parse-temperature 'warm) = (warm) )
   ( (parse-temperature 'cold) = (cold) )

   ( (hot? (hot)) ==> #t )
   ( (warm? (warm)) ==> #t )
   ( (cold? (cold)) ==> #t )

   ( (hot? (warm)) ==> #f )
   ( (hot? (cold)) ==> #f )

   ( (warm? (hot)) ==> #f )
   ( (warm? (cold)) ==> #f )

   ( (cold? (hot)) ==> #f )
   ( (cold? (warm)) ==> #f )

    )
 )
