;;; $Id: tc-scheme-scanner.tst,v 1.5 2006/01/18 23:17:27 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

(require (lib "tc-scheme-scanner.scm" "typedscm")
	 ;; (lib "tc-char-seq-as-list.scm" "typedscm")
	 (lib "tc-char-seq-as-stream.scm" "typedscm")
	 ;; (lib "tc-token-seq-as-list.scm" "typedscm"))
	 (lib "tc-token-seq-as-stream.scm" "typedscm"))

(tc:token-seq-for-each pretty-print
 (tc:character-string-scanner
  "; a comment
   'x #t #f #\\c #\\newline #\\space
   123 456.75e10 0.3 .4 -i #i3.7e-5 
   'a-symbol `another-sym ;; and another comment! ((((
   '(3.4 4 . 5) ... (tc:my-test? (lambda (x) (quote y)))
   '#( -4 -7.32 #o62 #b0011 #xff `(,x ,@ls))
   "))

(tc:token-seq-for-each pretty-print
 (tc:character-string-scanner "+ - -> -- ++ +&? #\\^a (f #\\^) x#3"))

(tc:token-seq-for-each pretty-print
 (tc:character-string-scanner "+ - -> . ... @ (,x ,@ls)"))

;(set! *tc:allow-tokens-not-in-R5RS* #f)
;
;(tc:token-seq-for-each pretty-print
; (tc:character-string-scanner "+ - -> . ... "))
